Package org.jboss.resteasy.specimpl

## Class MultivaluedTreeMap<K,​V>

- java.lang.Object
- - org.jboss.resteasy.specimpl.MultivaluedTreeMap<K,​V>

- All Implemented Interfaces:
    `Serializable`, `Map<K,​List<V>>`, `javax.ws.rs.core.MultivaluedMap<K,​V>`
  Direct Known Subclasses:
    `CaseInsensitiveMap`

      public class MultivaluedTreeMap<K,​V>
      extends Object
      implements javax.ws.rs.core.MultivaluedMap<K,​V>, Serializable

  Version:
    $Revision: 1 $
  Author:
    Bill Burke
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K extends Object,​V extends Object>`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MultivaluedTreeMap()` |
    `MultivaluedTreeMap​(Comparator<K> keyComparator)` | Used to create a CaseInsensitiveMap.
    `MultivaluedTreeMap​(Map<K,​V> map)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `add​(K key, V value)` |
    `static <K,​V> void` | `addAll​(javax.ws.rs.core.MultivaluedMap<K,​V> src, javax.ws.rs.core.MultivaluedMap<K,​V> dest)` |
    `void` | `addAll​(K key, List<V> valueList)` |
    `void` | `addAll​(K key, V... newValues)` |
    `void` | `addFirst​(K key, V value)` |
    `void` | `clear()` |
    `MultivaluedTreeMap<K,​V>` | `clone()` |
    `static <K,​V> MultivaluedTreeMap<K,​V>` | `clone​(javax.ws.rs.core.MultivaluedMap<K,​V> src)` |
    `boolean` | `containsKey​(Object key)` |
    `boolean` | `containsValue​(Object value)` |
    `static <K,​V> void` | `copy​(javax.ws.rs.core.MultivaluedMap<K,​V> src, javax.ws.rs.core.MultivaluedMap<K,​V> dest)` |
    `Set<Map.Entry<K,​List<V>>>` | `entrySet()` |
    `boolean` | `equals​(Object o)` |
    `boolean` | `equalsIgnoreValueOrder​(javax.ws.rs.core.MultivaluedMap<K,​V> omap)` |
    `List<V>` | `get​(Object key)` |
    `V` | `getFirst​(K key)` |
    `int` | `hashCode()` |
    `boolean` | `isEmpty()` |
    `Set<K>` | `keySet()` |
    `List<V>` | `put​(K key, List<V> value)` |
    `void` | `putAll​(Map<? extends K,​? extends List<V>> t)` |
    `void` | `putSingle​(K key, V value)` |
    `List<V>` | `remove​(Object key)` |
    `int` | `size()` |
    `String` | `toString()` |
    `static String` | `toString​(javax.ws.rs.core.MultivaluedMap<?,​?> map, String delimiter)` |
    `Collection<List<V>>` | `values()` |

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Constructor Detail

    - #### MultivaluedTreeMap

          public MultivaluedTreeMap()

    - #### MultivaluedTreeMap

          public MultivaluedTreeMap​(Comparator<K> keyComparator)

      Used to create a CaseInsensitiveMap.
      Parameters:
        `keyComparator` - key comparator

    - #### MultivaluedTreeMap

          public MultivaluedTreeMap​(Map<K,​V> map)

  - ### Method Detail

    - #### add

          public void add​(K key,
                          V value)

      Specified by:
        `add` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`

    - #### getFirst

          public V getFirst​(K key)

      Specified by:
        `getFirst` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`

    - #### putSingle

          public void putSingle​(K key,
                                V value)

      Specified by:
        `putSingle` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`

    - #### clone

          public MultivaluedTreeMap<K,​V> clone()

      Overrides:
        `clone` in class `Object`

    - #### clone

          public static <K,​V> MultivaluedTreeMap<K,​V> clone​(javax.ws.rs.core.MultivaluedMap<K,​V> src)

    - #### copy

          public static <K,​V> void copy​(javax.ws.rs.core.MultivaluedMap<K,​V> src,
                                              javax.ws.rs.core.MultivaluedMap<K,​V> dest)

    - #### addAll

          public static <K,​V> void addAll​(javax.ws.rs.core.MultivaluedMap<K,​V> src,
                                                javax.ws.rs.core.MultivaluedMap<K,​V> dest)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### toString

          public static String toString​(javax.ws.rs.core.MultivaluedMap<?,​?> map,
                                        String delimiter)

    - #### clear

          public void clear()

      Specified by:
        `clear` in interface `Map<K,​V>`

    - #### containsKey

          public boolean containsKey​(Object key)

      Specified by:
        `containsKey` in interface `Map<K,​V>`

    - #### containsValue

          public boolean containsValue​(Object value)

      Specified by:
        `containsValue` in interface `Map<K,​V>`

    - #### entrySet

          public Set<Map.Entry<K,​List<V>>> entrySet()

      Specified by:
        `entrySet` in interface `Map<K,​V>`

    - #### equals

          public boolean equals​(Object o)

      Specified by:
        `equals` in interface `Map<K,​V>`
      Overrides:
        `equals` in class `Object`

    - #### get

          public List<V> get​(Object key)

      Specified by:
        `get` in interface `Map<K,​V>`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in interface `Map<K,​V>`
      Overrides:
        `hashCode` in class `Object`

    - #### isEmpty

          public boolean isEmpty()

      Specified by:
        `isEmpty` in interface `Map<K,​V>`

    - #### keySet

          public Set<K> keySet()

      Specified by:
        `keySet` in interface `Map<K,​V>`

    - #### put

          public List<V> put​(K key,
                             List<V> value)

      Specified by:
        `put` in interface `Map<K,​V>`

    - #### putAll

          public void putAll​(Map<? extends K,​? extends List<V>> t)

      Specified by:
        `putAll` in interface `Map<K,​V>`

    - #### remove

          public List<V> remove​(Object key)

      Specified by:
        `remove` in interface `Map<K,​V>`

    - #### size

          public int size()

      Specified by:
        `size` in interface `Map<K,​V>`

    - #### values

          public Collection<List<V>> values()

      Specified by:
        `values` in interface `Map<K,​V>`

    - #### addAll

          public void addAll​(K key,
                             V... newValues)

      Specified by:
        `addAll` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`

    - #### addAll

          public void addAll​(K key,
                             List<V> valueList)

      Specified by:
        `addAll` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`

    - #### addFirst

          public void addFirst​(K key,
                               V value)

      Specified by:
        `addFirst` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`

    - #### equalsIgnoreValueOrder

          public boolean equalsIgnoreValueOrder​(javax.ws.rs.core.MultivaluedMap<K,​V> omap)

      Specified by:
        `equalsIgnoreValueOrder` in interface `javax.ws.rs.core.MultivaluedMap<K,​V>`